"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class VariantInterpretationLog(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "caseId",
        "groupId",
        "timestamp",
        "user",
        "variantClassification",
        "variantCoordinates",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "comments": reports_6_4_0.UserComment,
            "flaggedPublications": reports_6_4_0.Publication,
            "genomicEntities": reports_6_4_0.GenomicEntity,
            "selectedReportEvents": reports_6_4_0.SelectedReportEvent,
            "user": reports_6_4_0.User,
            "variantClassification": reports_6_4_0.GuidelineBasedVariantClassification,
            "variantCoordinates": reports_6_4_0.VariantCoordinates,
            "variantValidation": reports_6_4_0.VariantValidation,
            "versionControl": reports_6_4_0.ReportVersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "phenotypesSolved": reports_6_4_0.PhenotypesSolved,
            "reportCategory": reports_6_4_0.ReportCategory,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import reports as reports_6_4_0

        return {
            "org.gel.models.report.avro.UserComment": reports_6_4_0.UserComment,
            "org.gel.models.report.avro.Publication": reports_6_4_0.Publication,
            "org.gel.models.report.avro.GenomicEntity": reports_6_4_0.GenomicEntity,
            "org.gel.models.report.avro.PhenotypesSolved": reports_6_4_0.PhenotypesSolved,
            "org.gel.models.report.avro.ReportCategory": reports_6_4_0.ReportCategory,
            "org.gel.models.report.avro.SelectedReportEvent": reports_6_4_0.SelectedReportEvent,
            "org.gel.models.report.avro.User": reports_6_4_0.User,
            "org.gel.models.report.avro.GuidelineBasedVariantClassification": reports_6_4_0.GuidelineBasedVariantClassification,
            "org.gel.models.report.avro.VariantCoordinates": reports_6_4_0.VariantCoordinates,
            "org.gel.models.report.avro.VariantValidation": reports_6_4_0.VariantValidation,
            "org.gel.models.report.avro.ReportVersionControl": reports_6_4_0.ReportVersionControl,
            "org.gel.models.report.avro.VariantInterpretationLog": reports_6_4_0.VariantInterpretationLog,
        }

    __slots__ = [
        "caseId",
        "groupId",
        "timestamp",
        "user",
        "variantClassification",
        "variantCoordinates",
        "versionControl",
        "Artifact",
        "additionalInfo",
        "comments",
        "decisionSupportSystemFilters",
        "flaggedPublications",
        "genomicEntities",
        "phenotypesSolved",
        "reportCategory",
        "selectedCdnaChange",
        "selectedProteinChange",
        "selectedReportEvents",
        "variantValidation",
    ]

    def __init__(
        self,
        caseId,
        groupId,
        timestamp,
        user,
        variantClassification,
        variantCoordinates,
        versionControl,
        Artifact=None,
        additionalInfo=None,
        comments=None,
        decisionSupportSystemFilters=None,
        flaggedPublications=None,
        genomicEntities=None,
        phenotypesSolved=None,
        reportCategory=None,
        selectedCdnaChange=None,
        selectedProteinChange=None,
        selectedReportEvents=None,
        variantValidation=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_4_0.VariantInterpretationLog model.

        :param caseId:
            Interpretation request ID including CIP prefix and version suffix
            (e.g. SAP-1234-1)
        :type caseId: str
        :param groupId:
            GeL group ID. For GMS cases this will be the referral ID. For 100k
            rare disease cases this will be the family ID. For 100k
            cancer cases this will be the participant ID.
        :type groupId: str
        :param timestamp:
            Date and time variant was classified (ISO 8601 datetime with seconds
            and timezone e.g. 2020-11-23T15:52:36+00:00)
        :type timestamp: str
        :param user:
            User who set classification
        :type user: User
        :param variantClassification:
            Guideline-based variant classification
        :type variantClassification: GuidelineBasedVariantClassification
        :param variantCoordinates:
            Variant coordinates
        :type variantCoordinates: VariantCoordinates
        :param versionControl:
            Model version number
        :type versionControl: ReportVersionControl
        :param Artifact:
            User has marked the variant as an artefact
        :type Artifact: None | boolean
        :param additionalInfo:
            Additional information relevant to this variant interpretation
        :type additionalInfo: None | dict[str, str]
        :param comments:
            User comments attached to this variant in this case
        :type comments: None | list[UserComment]
        :param decisionSupportSystemFilters:
            Filter settings applied at time variant was classified
        :type decisionSupportSystemFilters: None | dict[str, str]
        :param flaggedPublications:
            Publications flagged by the user as relevant
        :type flaggedPublications: None | list[Publication]
        :param genomicEntities:
            Genomic entities associated with this variant interpretation e.g. gene
        :type genomicEntities: None | list[GenomicEntity]
        :param phenotypesSolved:
            Was this variant recorded as explaining the patient's phenotype?
        :type phenotypesSolved: None | PhenotypesSolved
        :param reportCategory:
            The decision on whether to report this variant or not as recorded at
            time of interpretation.
        :type reportCategory: None | ReportCategory
        :param selectedCdnaChange:
            HGVS cDNA change for transcript selected by user. Format
            <TranscriptID>:<HGVS> e.g. ENST00000621744:c.8837T>C
        :type selectedCdnaChange: None | str
        :param selectedProteinChange:
            HGVS protein change for transcript selected by user. Format
            <ProteinID>:<HGVS> e.g. ENSP00000478752:p.Val2946Ala
        :type selectedProteinChange: None | str
        :param selectedReportEvents:
            Report event(s) selected by user when interpreting this variant.
            Contains information such as phenotype and mode of
            inheritance.
        :type selectedReportEvents: None | list[SelectedReportEvent]
        :param variantValidation:
            Independent validation of variants
        :type variantValidation: None | VariantValidation
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.4.0"
